(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["jssNested"] = factory();
	else
		root["jssNested"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports.default = jssNested;

	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

	var consoleWarn = console.warn.bind(console); // eslint-disable-line no-console
	var parentRegExp = /&/g;
	var refRegExp = /\$(\w+)/g;

	/**
	 * Convert nested rules to separate, remove them from original styles.
	 *
	 * @param {Rule} rule
	 * @api public
	 */
	function jssNested() {
	  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

	  var _ref$warn = _ref.warn;
	  var warn = _ref$warn === undefined ? consoleWarn : _ref$warn;

	  // Get a function to be used for $ref replacement.
	  function getReplaceRef(container) {
	    return function (match, name) {
	      var rule = container.getRule(name);
	      if (rule) return rule.selector;
	      warn('[JSS] Could not find the referenced rule "' + name + '".');
	      return name;
	    };
	  }

	  function addConditional(name, rule, container) {
	    var conditionalContainer = container.getRule(name);

	    // Check if conditional rule already exists in container.
	    if (!conditionalContainer) {
	      // Add conditional to container because it does not exist yet.
	      container.addRule(name, _defineProperty({}, rule.name, rule.style[name]));
	      return;
	    }

	    // It exists, so now check if we have already defined styles
	    // for example @media print { .some-style { display: none; } } .
	    var ruleToExtend = conditionalContainer.getRule(rule.name);

	    if (ruleToExtend) {
	      ruleToExtend.style = _extends({}, ruleToExtend.style, rule.style[name]);
	      return;
	    }

	    // Conditional rule in container has no rule so create it.
	    conditionalContainer.addRule(rule.name, rule.style[name]);
	  }

	  return function (rule) {
	    if (rule.type !== 'regular') return;
	    var container = rule.options.parent;
	    var options = void 0;
	    var replaceRef = void 0;
	    var index = void 0;

	    for (var prop in rule.style) {
	      var isNested = prop[0] === '&';
	      var isNestedConditional = prop[0] === '@';

	      if (!isNested && !isNestedConditional) continue;

	      if (!options) {
	        var level = rule.options.level;

	        level = level === undefined ? 1 : level + 1;
	        if (level > 1) warn('[JSS] Nesting is too deep "' + prop + '".');
	        options = _extends({}, rule.options, { named: false, level: level });
	      }
	      index = (index === undefined ? container.indexOf(rule) : index) + 1;
	      options.index = index;

	      if (isNested) {
	        // Lazily create the ref replacer function just once for all nested rules within
	        // the sheet.
	        if (!replaceRef) replaceRef = getReplaceRef(container);
	        var name = prop
	        // Replace all & by the parent selector.
	        .replace(parentRegExp, rule.selector)
	        // Replace all $ref.
	        .replace(refRegExp, replaceRef);
	        container.addRule(name, rule.style[prop], options);
	      } else if (isNestedConditional) {
	        addConditional(prop, rule, container);
	      }

	      delete rule.style[prop];
	    }
	  };
	}

/***/ }
/******/ ])
});
;